<template>
  <v-menu
    v-model="showMenu"
    :close-on-content-click="false"
    transition="scale-transition"
    offset-y
    max-width="290px"
    min-width="auto"
  >
    <template #activator="{ on, attrs }">
      <v-text-field
        v-model="formattedDate"
        :label="label"
        append-icon="mdi-calendar"
        readonly
        outlined
        v-bind="attrs"
        v-on="on"
      />
    </template>
    <v-date-picker
      :value="formattedValue"
      no-title
      :min="min"
      @input="handleDateInput"
    />
  </v-menu>
</template>

<script>
import { format, parse } from 'date-fns';

export default {
  name: 'DatePicker',
  props: {
    value: {
      type: Date,
      default: null,
    },
    label: {
      type: String,
      default: 'Fecha',
    },
  },
  emits: ['input'],
  data() {
    const now = new Date();
    return {
      now,
      showMenu: false,
      date: this.value,
    };
  },
  computed: {
    min() {
      return this.now.toISOString();
    },
    formattedValue() {
      return this.value?.toISOString() ?? null;
    },
    formattedDate() {
      if (!this.date) { return null; }
      return format(this.date, 'dd / MM / yyyy');
    },
  },
  methods: {
    handleDateInput(input) {
      this.showMenu = false;
      this.date = parse(input, 'yyyy-MM-dd', new Date());
      this.$emit('input', this.date);
    },
  },
};
</script>
